// <auto-generated />
//
// To parse this JSON data, add NuGet 'Newtonsoft.Json' then do:
//
//    using BO4EDotNet;
//
//    var verbrauch = Verbrauch.FromJson(jsonString);

namespace BO4EDotNet
{
    using System;
    using System.Collections.Generic;

    using System.Globalization;
    using Newtonsoft.Json;
    using Newtonsoft.Json.Converters;

    /// <summary>
    /// Abbildung eines zeitlich abgegrenzten Verbrauchs
    ///
    /// .. raw:: html
    ///
    /// <object data="../_static/images/bo4e/com/Verbrauch.svg" type="image/svg+xml"></object>
    ///
    /// .. HINT::
    /// `Verbrauch JSON Schema
    /// <https://json-schema.app/view/%23?url=https://raw.githubusercontent.com/BO4E/BO4E-Schemas/v202401.2.1/src/bo4e_schemas/com/Verbrauch.json>`_
    /// </summary>
    public partial class Verbrauch
    {
        /// <summary>
        /// zusatz_attribute: Optional[list["ZusatzAttribut"]] = None
        ///
        /// # pylint: disable=duplicate-code
        /// model_config = ConfigDict(
        /// alias_generator=camelize,
        /// populate_by_name=True,
        /// extra="allow",
        /// # json_encoders is deprecated, but there is no easy-to-use alternative. The best way
        /// would be to create
        /// # an annotated version of Decimal, but you would have to use it everywhere in the
        /// pydantic models.
        /// # See this issue for more info: https://github.com/pydantic/pydantic/issues/6375
        /// json_encoders={Decimal: str},
        /// )
        /// </summary>
        [JsonProperty("_id")]
        public string Id { get; set; }

        /// <summary>
        /// Version der BO-Struktur aka "fachliche Versionierung"
        /// </summary>
        [JsonProperty("_version")]
        public string Version { get; set; }

        /// <summary>
        /// Gibt die Einheit zum jeweiligen Wert an
        /// </summary>
        [JsonProperty("einheit")]
        public Mengeneinheit? Einheit { get; set; }

        /// <summary>
        /// Exklusives Ende des Zeitraumes, für den der Verbrauch angegeben wird
        /// </summary>
        [JsonProperty("enddatum")]
        public DateTimeOffset? Enddatum { get; set; }

        /// <summary>
        /// Messwertstatus includes the plausibility of the value
        /// </summary>
        [JsonProperty("messwertstatus")]
        public Messwertstatus? Messwertstatus { get; set; }

        /// <summary>
        /// Die OBIS-Kennzahl für den Wert, die festlegt, welche Größe mit dem Stand gemeldet wird,
        /// z.B. '1-0:
        /// </summary>
        [JsonProperty("obisKennzahl")]
        public string ObisKennzahl { get; set; }

        /// <summary>
        /// Inklusiver Beginn des Zeitraumes, für den der Verbrauch angegeben wird
        /// </summary>
        [JsonProperty("startdatum")]
        public DateTimeOffset? Startdatum { get; set; }

        /// <summary>
        /// Gibt den absoluten Wert der Menge an
        /// </summary>
        [JsonProperty("wert")]
        public double? Wert { get; set; }

        /// <summary>
        /// Gibt an, ob es sich um eine PROGNOSE oder eine MESSUNG handelt
        /// </summary>
        [JsonProperty("wertermittlungsverfahren")]
        public Wertermittlungsverfahren? Wertermittlungsverfahren { get; set; }

        [JsonProperty("zusatzAttribute")]
        public ZusatzAttribut[] ZusatzAttribute { get; set; }
    }

    /// <summary>
    /// Viele Datenobjekte weisen in unterschiedlichen Systemen eine eindeutige ID (Kundennummer,
    /// GP-Nummer etc.) auf.
    /// Beim Austausch von Datenobjekten zwischen verschiedenen Systemen ist es daher hilfreich,
    /// sich die eindeutigen IDs der anzubindenden Systeme zu merken.
    ///
    /// .. raw:: html
    ///
    /// <object data="../_static/images/bo4e/com/ZusatzAttribut.svg"
    /// type="image/svg+xml"></object>
    ///
    /// .. HINT::
    /// `ZusatzAttribut JSON Schema
    /// <https://json-schema.app/view/%23?url=https://raw.githubusercontent.com/BO4E/BO4E-Schemas/v202401.2.1/src/bo4e_schemas/ZusatzAttribut.json>`_
    /// </summary>
    public partial class ZusatzAttribut
    {
        /// <summary>
        /// Bezeichnung der externen Referenz (z.B. "microservice xyz" oder "SAP CRM GP-Nummer")
        /// </summary>
        [JsonProperty("name")]
        public string Name { get; set; }

        /// <summary>
        /// Bezeichnung der externen Referenz (z.B. "microservice xyz" oder "SAP CRM GP-Nummer")
        /// </summary>
        [JsonProperty("wert")]
        public object Wert { get; set; }
    }

    /// <summary>
    /// Einheit: Messgrößen, die per Messung oder Vorgabe ermittelt werden können.
    /// </summary>
    public enum Mengeneinheit { Halbjahr, Jahr, Kubikmeter, Kvar, Kvarh, Kw, Kwh, Kwhk, Minute, Monat, Mw, Mwh, Prozent, Quartal, Sekunde, Stueck, Stunde, Tag, Var, Varh, ViertelStunde, W, Wh, Woche };

    /// <summary>
    /// Der Status eines Zählerstandes
    /// </summary>
    public enum Messwertstatus { Abgelesen, AngabeFuerLieferschein, Energiemengesummiert, Ersatzwert, Fehlt, NichtVerwendbar, Prognosewert, Vorlaeufigerwert, Vorschlagswert };

    /// <summary>
    /// Gibt an, ob es sich um eine Prognose oder eine Messung handelt, beispielsweise bei der
    /// Abbildung eines Verbrauchs.
    /// </summary>
    public enum Wertermittlungsverfahren { Messung, Prognose };

    public partial class Verbrauch
    {
        public static Verbrauch FromJson(string json) => JsonConvert.DeserializeObject<Verbrauch>(json, BO4EDotNet.Converter.Settings);
    }

    public static class Serialize
    {
        public static string ToJson(this Verbrauch self) => JsonConvert.SerializeObject(self, BO4EDotNet.Converter.Settings);
    }

    internal static class Converter
    {
        public static readonly JsonSerializerSettings Settings = new JsonSerializerSettings
        {
            MetadataPropertyHandling = MetadataPropertyHandling.Ignore,
            DateParseHandling = DateParseHandling.None,
            Converters =
            {
                MengeneinheitConverter.Singleton,
                MesswertstatusConverter.Singleton,
                WertermittlungsverfahrenConverter.Singleton,
                new IsoDateTimeConverter { DateTimeStyles = DateTimeStyles.AssumeUniversal }
            },
        };
    }

    internal class MengeneinheitConverter : JsonConverter
    {
        public override bool CanConvert(Type t) => t == typeof(Mengeneinheit) || t == typeof(Mengeneinheit?);

        public override object ReadJson(JsonReader reader, Type t, object existingValue, JsonSerializer serializer)
        {
            if (reader.TokenType == JsonToken.Null) return null;
            var value = serializer.Deserialize<string>(reader);
            switch (value)
            {
                case "HALBJAHR":
                    return Mengeneinheit.Halbjahr;
                case "JAHR":
                    return Mengeneinheit.Jahr;
                case "KUBIKMETER":
                    return Mengeneinheit.Kubikmeter;
                case "KVAR":
                    return Mengeneinheit.Kvar;
                case "KVARH":
                    return Mengeneinheit.Kvarh;
                case "KW":
                    return Mengeneinheit.Kw;
                case "KWH":
                    return Mengeneinheit.Kwh;
                case "KWHK":
                    return Mengeneinheit.Kwhk;
                case "MINUTE":
                    return Mengeneinheit.Minute;
                case "MONAT":
                    return Mengeneinheit.Monat;
                case "MW":
                    return Mengeneinheit.Mw;
                case "MWH":
                    return Mengeneinheit.Mwh;
                case "PROZENT":
                    return Mengeneinheit.Prozent;
                case "QUARTAL":
                    return Mengeneinheit.Quartal;
                case "SEKUNDE":
                    return Mengeneinheit.Sekunde;
                case "STUECK":
                    return Mengeneinheit.Stueck;
                case "STUNDE":
                    return Mengeneinheit.Stunde;
                case "TAG":
                    return Mengeneinheit.Tag;
                case "VAR":
                    return Mengeneinheit.Var;
                case "VARH":
                    return Mengeneinheit.Varh;
                case "VIERTEL_STUNDE":
                    return Mengeneinheit.ViertelStunde;
                case "W":
                    return Mengeneinheit.W;
                case "WH":
                    return Mengeneinheit.Wh;
                case "WOCHE":
                    return Mengeneinheit.Woche;
            }
            throw new Exception("Cannot unmarshal type Mengeneinheit");
        }

        public override void WriteJson(JsonWriter writer, object untypedValue, JsonSerializer serializer)
        {
            if (untypedValue == null)
            {
                serializer.Serialize(writer, null);
                return;
            }
            var value = (Mengeneinheit)untypedValue;
            switch (value)
            {
                case Mengeneinheit.Halbjahr:
                    serializer.Serialize(writer, "HALBJAHR");
                    return;
                case Mengeneinheit.Jahr:
                    serializer.Serialize(writer, "JAHR");
                    return;
                case Mengeneinheit.Kubikmeter:
                    serializer.Serialize(writer, "KUBIKMETER");
                    return;
                case Mengeneinheit.Kvar:
                    serializer.Serialize(writer, "KVAR");
                    return;
                case Mengeneinheit.Kvarh:
                    serializer.Serialize(writer, "KVARH");
                    return;
                case Mengeneinheit.Kw:
                    serializer.Serialize(writer, "KW");
                    return;
                case Mengeneinheit.Kwh:
                    serializer.Serialize(writer, "KWH");
                    return;
                case Mengeneinheit.Kwhk:
                    serializer.Serialize(writer, "KWHK");
                    return;
                case Mengeneinheit.Minute:
                    serializer.Serialize(writer, "MINUTE");
                    return;
                case Mengeneinheit.Monat:
                    serializer.Serialize(writer, "MONAT");
                    return;
                case Mengeneinheit.Mw:
                    serializer.Serialize(writer, "MW");
                    return;
                case Mengeneinheit.Mwh:
                    serializer.Serialize(writer, "MWH");
                    return;
                case Mengeneinheit.Prozent:
                    serializer.Serialize(writer, "PROZENT");
                    return;
                case Mengeneinheit.Quartal:
                    serializer.Serialize(writer, "QUARTAL");
                    return;
                case Mengeneinheit.Sekunde:
                    serializer.Serialize(writer, "SEKUNDE");
                    return;
                case Mengeneinheit.Stueck:
                    serializer.Serialize(writer, "STUECK");
                    return;
                case Mengeneinheit.Stunde:
                    serializer.Serialize(writer, "STUNDE");
                    return;
                case Mengeneinheit.Tag:
                    serializer.Serialize(writer, "TAG");
                    return;
                case Mengeneinheit.Var:
                    serializer.Serialize(writer, "VAR");
                    return;
                case Mengeneinheit.Varh:
                    serializer.Serialize(writer, "VARH");
                    return;
                case Mengeneinheit.ViertelStunde:
                    serializer.Serialize(writer, "VIERTEL_STUNDE");
                    return;
                case Mengeneinheit.W:
                    serializer.Serialize(writer, "W");
                    return;
                case Mengeneinheit.Wh:
                    serializer.Serialize(writer, "WH");
                    return;
                case Mengeneinheit.Woche:
                    serializer.Serialize(writer, "WOCHE");
                    return;
            }
            throw new Exception("Cannot marshal type Mengeneinheit");
        }

        public static readonly MengeneinheitConverter Singleton = new MengeneinheitConverter();
    }

    internal class MesswertstatusConverter : JsonConverter
    {
        public override bool CanConvert(Type t) => t == typeof(Messwertstatus) || t == typeof(Messwertstatus?);

        public override object ReadJson(JsonReader reader, Type t, object existingValue, JsonSerializer serializer)
        {
            if (reader.TokenType == JsonToken.Null) return null;
            var value = serializer.Deserialize<string>(reader);
            switch (value)
            {
                case "ABGELESEN":
                    return Messwertstatus.Abgelesen;
                case "ANGABE_FUER_LIEFERSCHEIN":
                    return Messwertstatus.AngabeFuerLieferschein;
                case "ENERGIEMENGESUMMIERT":
                    return Messwertstatus.Energiemengesummiert;
                case "ERSATZWERT":
                    return Messwertstatus.Ersatzwert;
                case "FEHLT":
                    return Messwertstatus.Fehlt;
                case "NICHT_VERWENDBAR":
                    return Messwertstatus.NichtVerwendbar;
                case "PROGNOSEWERT":
                    return Messwertstatus.Prognosewert;
                case "VORLAEUFIGERWERT":
                    return Messwertstatus.Vorlaeufigerwert;
                case "VORSCHLAGSWERT":
                    return Messwertstatus.Vorschlagswert;
            }
            throw new Exception("Cannot unmarshal type Messwertstatus");
        }

        public override void WriteJson(JsonWriter writer, object untypedValue, JsonSerializer serializer)
        {
            if (untypedValue == null)
            {
                serializer.Serialize(writer, null);
                return;
            }
            var value = (Messwertstatus)untypedValue;
            switch (value)
            {
                case Messwertstatus.Abgelesen:
                    serializer.Serialize(writer, "ABGELESEN");
                    return;
                case Messwertstatus.AngabeFuerLieferschein:
                    serializer.Serialize(writer, "ANGABE_FUER_LIEFERSCHEIN");
                    return;
                case Messwertstatus.Energiemengesummiert:
                    serializer.Serialize(writer, "ENERGIEMENGESUMMIERT");
                    return;
                case Messwertstatus.Ersatzwert:
                    serializer.Serialize(writer, "ERSATZWERT");
                    return;
                case Messwertstatus.Fehlt:
                    serializer.Serialize(writer, "FEHLT");
                    return;
                case Messwertstatus.NichtVerwendbar:
                    serializer.Serialize(writer, "NICHT_VERWENDBAR");
                    return;
                case Messwertstatus.Prognosewert:
                    serializer.Serialize(writer, "PROGNOSEWERT");
                    return;
                case Messwertstatus.Vorlaeufigerwert:
                    serializer.Serialize(writer, "VORLAEUFIGERWERT");
                    return;
                case Messwertstatus.Vorschlagswert:
                    serializer.Serialize(writer, "VORSCHLAGSWERT");
                    return;
            }
            throw new Exception("Cannot marshal type Messwertstatus");
        }

        public static readonly MesswertstatusConverter Singleton = new MesswertstatusConverter();
    }

    internal class WertermittlungsverfahrenConverter : JsonConverter
    {
        public override bool CanConvert(Type t) => t == typeof(Wertermittlungsverfahren) || t == typeof(Wertermittlungsverfahren?);

        public override object ReadJson(JsonReader reader, Type t, object existingValue, JsonSerializer serializer)
        {
            if (reader.TokenType == JsonToken.Null) return null;
            var value = serializer.Deserialize<string>(reader);
            switch (value)
            {
                case "MESSUNG":
                    return Wertermittlungsverfahren.Messung;
                case "PROGNOSE":
                    return Wertermittlungsverfahren.Prognose;
            }
            throw new Exception("Cannot unmarshal type Wertermittlungsverfahren");
        }

        public override void WriteJson(JsonWriter writer, object untypedValue, JsonSerializer serializer)
        {
            if (untypedValue == null)
            {
                serializer.Serialize(writer, null);
                return;
            }
            var value = (Wertermittlungsverfahren)untypedValue;
            switch (value)
            {
                case Wertermittlungsverfahren.Messung:
                    serializer.Serialize(writer, "MESSUNG");
                    return;
                case Wertermittlungsverfahren.Prognose:
                    serializer.Serialize(writer, "PROGNOSE");
                    return;
            }
            throw new Exception("Cannot marshal type Wertermittlungsverfahren");
        }

        public static readonly WertermittlungsverfahrenConverter Singleton = new WertermittlungsverfahrenConverter();
    }
}
